//*************************************************************************************
// 	: SQ7653_I2C_Slave.c
// 汾		: V1.0 2020/07/17A
// 		: I2C ʹú (I2CƳ)
// ע		: I2C غ㼯ڱӳ
//**************************************************************************************
#include "main.h"


//*********************************************************************
// 	: I2C0_Init()
// 	: I2C0 ʼ
// ע		: I2C0 ùܽšģʽ		  
//*********************************************************************
void I2C0_Init(){
	
//====== I2C0ܽųʼ ======
//--SDA0 (P0.7) ; SCL0 (P0.6)-------
//  P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ

	P0CFGCR = 0xF2;  				    // P0.7趨ΪSDA0	1 111 0010
	P0CFGCR = 0xE2;					    // P0.6趨ΪSCL0	1 110 0010

//====== ܿ(Enable) ======
	PCKEN2_I2C0 = 1;                    // ȿݴò,I2C0 Enable
    
//====== 趨 ======    
    
	SBI0CR1_ACK = 1;                    // Ӧģʽ(ACK enable)
	SBI0CR1_BC = 0x00;                  // (λ)9bit = 8bit + 1bit(ACK)
	SBI0CR1_SCK = SCK_HI_135_LO_138;    // ģʽƵʽλ(SCL pin)ʱ ֮趨

	//---I2C0ΪSlave趨Slaveַ
	I2C0AR = SLAVE_ADDR << 1;			// ôģʽַ(Slaveַ)I2C0AR[7:1]
	
	//---ΪSlave mode趨 SBICR2<PIN> , <SBIM>
	SBI0CR2 = 0x18;						// Slave mode 0001 1000

}


//SBI0CR2
//-----bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ---------
//---  <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ---------
//---  <MST>   1 : Master
//             0 : Slave
//---  <TRX>   1 :    ; 0: 
//---  <BB>    1 : ʼ
//             0 : ֹͣ
//---  <PIN>   1 : ȡжϷ
//
//---  <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//---  <SWRST> ÿʼλ  
//----------------------------------------------------------------------



//*********************************************************************
// 	: I2C0_IntEnable()
// 	: I2C0ж
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C0_IntEnable(void){
	__ASM("DI");						// ֹпж
    
	IFR_I2C0_IRQ = 0;                   // ж
	IER_I2C0_IRQ = 1;	                // I2C0ж(Enable)
    
	__ASM("EI");						// пж
}


//*********************************************************************
// 	: I2C0_IntDisable() 
// 	: ֹI2C0ж
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C0_IntDisable(void){
	__ASM("DI");						// ֹпж
    
	IFR_I2C0_IRQ = 0;                   // ж
	IER_I2C0_IRQ = 0;	                // I2C0жϽֹ
    
	__ASM("EI");						// пж	
}




//*********************************************************************
// 	: I2C_AckEnable()
// 	: I2CǷһbitACKѶ
// ע		: 
//            enable : 1 
//				       0 ֹ
//*********************************************************************
void I2C_AckEnable(unsigned char enable){
	SBI0CR1_ACK = enable;				// I2C0 һbitACKѶ

}




//*********************************************************************
// 	: IsAck()
// 	: I2CǷACK
// ע		: 
//            return : 1 : NACK
//					   0 : ACK
//*********************************************************************
unsigned char IsAck(){
	if(SBI0SR_LRB ==0){
	return SBI0SR_LRB;
	
	}
	else {								// SBI0SR_LRB =1 NACK
	return I2C_NACK;
	}
	
	
}



// //*********************************************************************
// // 	: NACK_Stop_I2C()
// // 	: I2CǷACKΪNACKI2C ִзStop,ش0
// // ע		: 
// //*********************************************************************
// void NACK_Stop_I2C(){
// 	if(IsAck()==I2C_NACK){
// 	I2C_Stop();							// I2C ִзStop
// 	return 0;
// 	
// 	}
// 	
// 
// }



//*********************************************************************
// 	: I2C_BufCount()
// 	: I2Cbit
// ע		: 
//            bufcount : 
//                   BC_8bit      0x00
//                   BC_1bit      0x01
//                   BC_2bit      0x02
//                   BC_3bit      0x03
//                   BC_4bit      0x04
//                   BC_5bit      0x05
//                   BC_6bit      0x06
//                   BC_7bit      0x07 
//*********************************************************************
void I2C_BufCount(unsigned char bufcount){
	SBI0CR1_BC = bufcount;


}


//*********************************************************************
// 	: I2C_ReadState()
// 	: ȡI2C֮״̬
// ע		: 
//*********************************************************************
unsigned char I2C_ReadState(){
	return SBI0SR;						// ȡI2C0֮״̬


}


//*********************************************************************
// 	: I2C_SetBufvalue()
// 	: 趨I2C buffer
// ע		: 
//            data:  buffer
//*********************************************************************
void I2C_SetBufvalue(unsigned char data){
	SBI0DBR = data;


}



//*********************************************************************
// 	: I2C_ReadBufvalue()
// 	: I2C buffer
// ע		: 
//            return: buffer
//*********************************************************************
unsigned char I2C_ReadBufvalue(){
	return SBI0DBR;						// ش0ݻڵ


}


//*********************************************************************
// 	: I2C_FinishSlaveTx() [Slave mode]
// 	: I2C Slaveɳ,ҪΪͷI2C,һI2C˳ս
// ע		: 
//*********************************************************************
void I2C_FinishSlaveTx(){
	SBI0CR2 = 0x58;
	SBI0CR2 = 0x18;
	
	
}


//*********************************************************************
// 	: I2C_Reset()
// 	: I2C software reset. SBI0CR1,I2C0AR,SBI0CR2 ,SBI0CR2<SBIM>
// ע		: λ
//*********************************************************************
void I2C_Reset(){
	SBI0CR2 = 0x1A;						// дSWRST[1:0]=0x02
	SBI0CR2 = 0x19;						// дSWRST[1:0]=0x01

}


//*********************************************************************
// 	: __interrupt I2C0_IRQ()
// 	: I2C0 жӳ
// ע		:
//*********************************************************************
void __interrupt I2C0_IRQ(void)
{
	__asm("NOP");						// ָ

	I2C_Slave_Int(&i2c_slave);
}



//*********************************************************************
// 	: I2C_Slave_Int()
// 	: 
// ע		: 
//*********************************************************************
void I2C_Slave_Int(I2C_SlavePacket* pi2c){
	unsigned char tmp;
	if(I2C_ReadState()&SBISR_TX){
		// ͳ
		if(I2C_ReadState()&SBISR_AAS){	  	  // ַԼ
			// slaveַǺ
			pi2c->status = I2C_Slave_read;
			// I2C readҪĳ
			if(pi2c->cmd == 0x09){			  // յָΪ0x09
				LED1_out = 0;
				
				pi2c->buf[0] = 0x12;
				pi2c->buf[1] = 0x34;
				pi2c->len = 2;                // ͳ趨Ϊ2
			}
			else if(pi2c->cmd == 0x0A){	  // յָΪ0xAA
			    LED2_out = 0;
			
				pi2c->buf[0] = 0x55;
				pi2c->buf[1] = 0xAA;
				pi2c->len = 2;                // ͳ趨Ϊ2
			}
			else{							  // յ֧Ԯָ(ǰĳƶ0x090xAA)
				pi2c->len = 0;                // ͳ趨Ϊ0
			}
			
			// ¾Ƿͳһ
			pi2c->pointer= 0;
			if(pi2c->pointer >= pi2c->len){   // ȷǷҪͳ
				I2C_SetBufvalue(0xFF);    	  // ͳdummy data
			}
			else{
				I2C_SetBufvalue(pi2c->buf[pi2c->pointer]);	
			}				
		}
		else{
			if(I2C_ReadState()&SBISR_LRB){
				I2C_SetBufvalue(0x00);		      // Clear buf
				I2C_FinishSlaveTx();
			}
			else{
				if(pi2c->pointer >= pi2c->len){
					I2C_SetBufvalue(0xFF);
				}
				else{
				    I2C_SetBufvalue(pi2c->buf[pi2c->pointer]);
				}
			}			
		}
		pi2c->pointer++;
	}
	else{
		// 
		if(I2C_ReadState()&SBISR_AAS){
			// slaveַǺ
			pi2c->pointer = 0;
			pi2c->status = I2C_Slave_adr;
			tmp = I2C_ReadBufvalue();
			I2C_SetBufvalue(0x00);		         // Clear buf						
		}
		else{
		    if(pi2c->status == I2C_Slave_adr){
                pi2c->cmd = I2C_ReadBufvalue();
				pi2c->status = I2C_Slave_cmd;
				I2C_SetBufvalue(0x00);		 	 // Clear buf
			}
			else{
				pi2c->buf[pi2c->pointer] = I2C_ReadBufvalue();
				pi2c->pointer++;
				I2C_SetBufvalue(0x00);		 	 // Clear buf
			}
		}
	}
}


